package com.tptj.tool.hg.fineui.swing.element.layout;

import com.tptj.tool.hg.fineui.swing.element.Element;
import com.tptj.tool.hg.fineui.swing.element.VerticalFlowLayout;
import com.tptj.tool.hg.fineui.swing.element.layout.impl.BaseFineUILayout;
import com.tptj.tool.hg.fineui.swing.element.layout.impl.HorizontalLayout;
import com.tptj.tool.hg.fineui.swing.element.layout.impl.VerticalLayout;

import javax.swing.*;
import java.awt.*;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/11/1
 **/
public class HorizontalAdaptType extends AbstractLayoutType {
    @Override
    public LayoutManager init() {
        return new VerticalLayout(element, VerticalFlowLayout.TOP, 0, 0, true);
    }

    @Override
    public void layout(Element child, int idx) {
        int w = child.getRectStyleAttr("width", BaseFineUILayout.MAX_SIZE, BaseFineUILayout.NOT_EXIST);
        // 如果设置了宽度就需要居中，否则和vertical布局一致
        if (w > 0) {
            JComponent wrapComponent = new JPanel();
            wrapComponent.setOpaque(false);
            wrapComponent.setLayout(new FlowLayout(FlowLayout.CENTER, 0, 0));
            wrapComponent.add(child.getWrapper());
            element.getComponent().add(wrapComponent);
        } else {
            element.getComponent().add(child.getWrapper());
        }
    }
}
