package com.tptj.tool.hg.fineui.swing.element.layout;

import com.fr.log.FineLoggerFactory;
import com.tptj.tool.hg.fineui.swing.element.Element;

import java.util.HashMap;
import java.util.Map;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/11/1
 **/
public class LayoutBuilder {
    public static final String ABSOLUTE = "absolute";
    public static final String CENTER_ADAPT = "center_adapt";
    public static final String VERTICAL = "vertical";
    public static final String VERTICAL_ADAPT = "vertical_adapt";
    public static final String HORIZONTAL = "horizontal";
    public static final String HORIZONTAL_ADAPT = "horizontal_adapt";

    private LayoutBuilder(){

    }
    private static final Map<String,Class<? extends LayoutType>> types = new HashMap<String,Class<? extends LayoutType>>();
    static{
        types.put(ABSOLUTE,AbsoluteType.class);
        types.put(CENTER_ADAPT,CenterAdaptType.class);
        types.put(VERTICAL,VerticalType.class);
        types.put(VERTICAL_ADAPT,VerticalAdaptType.class);
        types.put(HORIZONTAL,HorizontalType.class);
        types.put(HORIZONTAL_ADAPT,HorizontalAdaptType.class);
    }

    public static LayoutType layout(String type,Element element){
        Class<? extends LayoutType> layout_type = types.get(type);
        if( null == layout_type  ){
            FineLoggerFactory.getLogger().error("不支持的布局：{}",type);
            layout_type = AbsoluteType.class;
        }
        try{
            LayoutType layout = layout_type.newInstance();
            layout.setElement(element);
            return layout;
        }catch(Exception e){
            FineLoggerFactory.getLogger().error(e,"布局失败{}，{}",type,e.getMessage());
        }
        AbsoluteType dft = new AbsoluteType();
        dft.setElement(element);
        return dft;
    }
}
