package com.tptj.tool.hg.fineui.swing.element.layout.impl;

import com.tptj.tool.hg.fineui.swing.element.Element;

import java.awt.*;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/11/1
 **/
public class AbsoluteLayout extends BaseFineUILayout {

    public AbsoluteLayout(Element element) {
        super(element);
    }

    @Override
    protected Rectangle getFineUIRect(Element child, int width, int height) {
        Dimension size = child.getWrapper().getPreferredSize();
        int w = child.getRectStyleAttr("width",width,NOT_EXIST);
        int h = child.getRectStyleAttr("height",height, NOT_EXIST);
        int l = child.getRectStyleAttr("left",width, NOT_EXIST);
        int r = child.getRectStyleAttr("right",width, NOT_EXIST);
        int t = child.getRectStyleAttr("top",height, NOT_EXIST);
        int b = child.getRectStyleAttr("bottom",height, NOT_EXIST);
        Rectangle rt = new Rectangle(l,t,w,h);
        if( w == NOT_EXIST ){
            if( l != NOT_EXIST && r != NOT_EXIST ){
                rt.width = width - l - r;
            }else{
                rt.width = size.width;
            }
        }
        if( h == NOT_EXIST ){
            if( t != NOT_EXIST && b != NOT_EXIST){
                rt.height = height - t - b;
            }else{
                rt.height = size.height;
            }
        }
        if( l == NOT_EXIST && r != NOT_EXIST ){
            rt.x = width - rt.width - r;
        }
        if( t == NOT_EXIST && b != NOT_EXIST){
            rt.y = height - rt.height - b;
        }
        //内外边距的计算可以在这里继续
        return rt;
    }

}
