package com.tptj.tool.hg.fineui.swing.stable;

import com.fr.stable.StringUtils;

import java.awt.*;
import java.util.HashMap;
import java.util.Map;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/11/1
 * 颜色转换工具
 **/
public class ColorUtils {
    private static final Map<String,Color> colors = new HashMap<String,Color>();
    static{
        colors.put("YELLOW",Color.YELLOW);
        colors.put("BLACK",Color.BLACK);
        colors.put("BLUE",Color.BLUE);
        colors.put("CYAN",Color.CYAN);
        colors.put("DARK_GRAY",Color.DARK_GRAY);
        colors.put("GRAY",Color.GRAY);
        colors.put("GREEN",Color.GREEN);
        colors.put("LIGHT_GRAY",Color.LIGHT_GRAY);
        colors.put("MAGENTA",Color.MAGENTA);
        colors.put("ORANGE",Color.ORANGE);
        colors.put("PINK",Color.PINK);
        colors.put("RED",Color.RED);
        colors.put("WHITE",Color.WHITE);
    }
    public static Color str2Color(String str) {
        if(StringUtils.isEmpty(str) ){
            return null;
        }
        str = str.toUpperCase().replaceAll(" ","");
        if(  str.startsWith("#") ){
            str = str.substring(1);
            if( str.length() < 5 ){
               StringBuilder sb = new StringBuilder();
               for( int i=0,len=str.length(); i<len; i++ ){
                   sb.append( str.charAt(i) ).append( str.charAt(i) );
               }
               str = sb.toString();
            }
            return new Color( Integer.parseInt(str,16),str.length() == 8 );
        }else if( str.startsWith("RGB") ){
            str = str.substring(4,str.length()-1);
            String [] parts = str.split(",");
            return new Color( Integer.parseInt(parts[0]), Integer.parseInt(parts[1]), Integer.parseInt(parts[2]) );
        }else if( str.startsWith("RGBA") ){
            str = str.substring(5,str.length()-1);
            String [] parts = str.split(",");
            return new Color( Integer.parseInt(parts[0]), Integer.parseInt(parts[1]), Integer.parseInt(parts[2]) , Integer.parseInt(parts[3]) );
        }
        return colors.get(str);
    }
}
