/**
 * Created by GUY on 2021/11/7.
 */

!(function () {
    // 实现一个简易版的ButtonGroup，FineUI中的ButtonGroup太复杂了。而且对于要单选多选这种功能，应该交给具体的List组件去解决。本ButtonGroup主要职责是在布局的基础之上提供刷新的功能
    var Widget = BI.inherit(BI.Widget, {
        render: function () {
            var self = this, o = this.options;
            var layout = o.layouts[0];
            // 将布局中的属性要处理下
            return BI.extend({}, layout, {
                ref: function (_ref) {
                    self.list = _ref;
                },
                items: o.items
            })
        },

        populate: function (items) {
            this.list.populate(items);
        }
    });
    BI.shortcut("swing.button_group", Widget);

    // 这里仅实现通过button_group来动态创建组件并能刷新的功能
    BI.config("bi.button_group", function (config) {
        return BI.extend({}, config, {
            type: "swing.button_group"
        })
    });
}());
