/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/10/29
 **/
!(function () {

    var Element = Java.type("com.tptj.tool.hg.fineui.swing.element.JPanelElement");
    $ = function (widget) {
        if (widget instanceof SwingElement) {
            return widget;
        }
        return new SwingElement(widget);
    };

    var SwingElement = function (widget) {
        this.init(widget);
        this._children = [];
    };

    _.extend(SwingElement.prototype, {
        init: function (widget) {
            var self = this;
            this[0] = this;
            // 一个element对应多个widget
            this.widgets = [widget];
            // 入口特殊处理一下
            if (widget === body) {
                this.java_el = widget;
            } else {
                this.java_el = new ((widget.options || {}).swingElement || Element)();
            }
            if (BI.isWidget(widget)) {
                this.widget = widget;
                if (!widget.mounted) {
                    widget.mounted = [];
                } else if (!BI.isArray(widget.mounted)) {
                    widget.mounted = [widget.mounted];
                }
                widget.mounted.push(function () {
                    self.mounted();
                });
            }
        }
    });
    _.extend(SwingElement.prototype, {
        parent: function () {
            return this._parent;
        },
        // 生命周期钩子
        mounted: function () {
            this._isMounted = true;
            this.java_el.mounted();
        },
        ref: function (obj) {
            this.java_el.ref(obj);
        },
        removeClass: function (clazz) {
            this.java_el.removeClass(clazz);
            return this;
        },
        data: function () {
            if (arguments.length == 1) {
                return this.java_el.getData(arguments[0]);
            } else {
                this.java_el.setData(arguments[0], arguments[1]);
            }
            return this;
        },
        css: function () {
            if (arguments.length == 1) {
                this.java_el.cssMap(arguments[0]);
            } else {
                this.java_el.css(arguments[0], arguments[1]);
            }
            return this;
        },
        unbind: function () {
            this.java_el.unbind();
            return this;
        },
        updateUI: function () {
            if (this._isMounted) {
                this.java_el.updateUI();
            }
        },
        destroy: function () {
            this.java_el.destroy();
        },
        addClass: function (clazz) {
            //console.info(this.java_el);
            this.java_el.addClass(clazz);
            return this;
        },
        attr: function () {
            if (arguments.length == 1) {
                return this.java_el.getAttr(arguments[0]);
            } else {
                this.java_el.setAttr(arguments[0], arguments[1]);
            }
            return this;
        },
        empty: function () {
            this._children = [];
            this.java_el.empty();
            return this;
        },
        layout: function (layoutType) {
            this.java_el.layout(layoutType);
        },
        append: function (element) {
            if (null == element.java_el.getComponent()) {
                var children = element.children();
                for (var i in children) {
                    this.append(children[i]);
                }
            } else {
                this._children.push(element);
                this.java_el.append(element.java_el);
                element._parent = this;
            }
            return this;
        },
        children: function () {
            return this._children;
        },
        appendTo: function (element) {
            element._children.push(this);
            this._parent = element;
            this.java_el.appendTo(element.java_el);
            return this;
        },
        appendChild: function (element) {
            this._children.push(element);
            this.java_el.append(element.java_el);
            element._parent = this;
            return this;
        },
        width: function () {
            if (arguments.length == 1) {
                this.java_el.setWidth(arguments[0]);
                return this;
            } else {
                return this.java_el.getWidth();
            }
        },
        height: function () {
            if (arguments.length == 1) {
                this.java_el.setHeight(arguments[0]);
                return this;
            } else {
                return this.java_el.getHeight();
            }
        },
        val: function () {
            if (arguments.length == 1) {
                this.java_el.setVal(arguments[0]);
                return this;
            } else {
                return this.java_el.getVal();
            }
        },

        populate: function (items) {
            this.java_el.populate(items);
        }
    });
})();