!(function () {
    var DEFAULT_CONFIG = {
        "bi.vertical_adapt": {
            verticalAlign: BI.VerticalAlign.Middle
        },
        "swing.vertical_adapt": {
            verticalAlign: BI.VerticalAlign.Middle
        },
        "bi.horizontal_adapt": {
            horizontalAlign: BI.HorizontalAlign.Center
        },
        "swing.horizontal_adapt": {
            horizontalAlign: BI.HorizontalAlign.Center
        },
        "bi.center_adapt": {
            verticalAlign: BI.VerticalAlign.Middle,
            horizontalAlign: BI.HorizontalAlign.Center
        },
        "swing.center_adapt": {
            verticalAlign: BI.VerticalAlign.Middle,
            horizontalAlign: BI.HorizontalAlign.Center
        }
    }
    var Service = BI.inherit(BI.OB, {
        layout: function (element, o) {
            var config = BI.extend({}, DEFAULT_CONFIG[o.type], o);
            if (config.verticalAlign === BI.VerticalAlign.Middle) {
                if (config.horizontalAlign === BI.HorizontalAlign.Center) {
                    element.layout("center_adapt");
                    return;
                }
                element.layout("vertical_adapt");
                return;
            }
            if (config.horizontalAlign === BI.HorizontalAlign.Center) {
                element.layout("horizontal_adapt");
                return;
            }
            if (config.type === "swing.vertical" || config.type === "bi.vertical") {
                element.layout("vertical");
                return;
            }
            if (config.type === "swing.horizontal" || config.type === "bi.horizontal") {
                element.layout("horizontal");
                return;
            }
            element.layout("absolute");
        }
    });
    BI.service("swing.layout.service", Service);
}());