/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/11/2
 * 静态布局的底层本质都是绝对布局，直接用一个模板方法统一重写
 **/
!(function () {
    var template = function( parent,type ){
        var Layout = BI.inherit(parent, {
            _mountChildren: function () {
                var self = this;
                for (var key in this._children) {
                    var child = this._children[key];
                    if (child.element !== self.element) {
                        this.element.append(child.element);
                    }
                }
                this.element.layout("absolute");
            }
        });
        BI.shortcut("swing."+type, Layout);
        BI.config("bi."+type, function (config) {
            return BI.extend({}, config, {
                type: "swing."+type
            })
        });
    };
    template(BI.AbsoluteLayout,"absolute");
    template(BI.BorderLayout,"border");
    template(BI.HTapeLayout,"htape");
    template(BI.VTapeLayout,"vtape");
    template(BI.GridLayout,"grid");
    template(BI.WindowLayout,"window");
})();