!(function () {
    var Model = BI.inherit(Fix.Model, {
        state: function () {
            return {
                items: [{
                    type: "bi.label",
                    text: "列表项1"
                }, {
                    type: "bi.label",
                    text: "列表项2"
                }]
            }
        },
        actions: {
            addItem: function () {
                this.model.items.push({
                    type: "bi.label",
                    text: "列表项" + (this.model.items.length + 1)
                })
            }
        }
    });
    BI.model("my.model", Model);

    var Widget = BI.inherit(BI.Widget, {
        _store: function () {
            return BI.Models.getModel("my.model");
        },
        props: {
            width: 600,
            height: 300
        },
        watch: {
            items: function (items) {
                this.list.populate(items);
            }
        },
        render: function () {
            var self = this;
            return {
                type: "bi.vtape",
                rowSize: [50, "fill"],
                items: [{
                    type: "bi.button",
                    text: "点击新增元素",
                    listeners: [{
                        eventName: "EVENT_CHANGE",
                        action: function (val) {
                            self.store.addItem();
                        }
                    }]
                }, {
                    type: "bi.button_group",
                    ref: function (_ref) {
                        self.list = _ref;
                    },
                    layouts: [{
                        type: "bi.vertical",
                        hgap: 30,
                        scrollable: true
                    }],
                    css: {
                        background: "rgb(200,200,200)"
                    },
                    items: this.model.items
                }]
            }
        }
    });
    BI.shortcut("my.app", Widget);

    BI.createWidget({
        type: "my.app",
        element: body
    });
})();