/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021/11/2
 **/
!(function () {

    var Widget = BI.inherit(BI.Widget, {
        props: {
            extraCls: "bi-text-editor bi-border bi-focus-shadow",
            hgap: 4,
            vgap: 2,
            lgap: 0,
            rgap: 0,
            tgap: 0,
            bgap: 0,
            validationChecker: BI.trueFunction,
            quitChecker: BI.trueFunction,
            allowBlank: true,
            watermark: "",
            errorText: "",
            height: 24
        },
        _initCurrent: function () {
            var o = this.options;
            if( o.inputType ){
                //如果涉及切换java控件类型的（比如 文本 数字 密码 等等的）需要提前进行转换
                this.element.attr("type",o.inputType);
            }
            Widget.superclass._initCurrent.apply(this, arguments);
        },
        render: function () {
            var o = this.options;
            if( o.textAlign ){
                this.element.css("text-align",o.textAlign);
            }
            if( o.textHeight ){
                this.element.css("line-height",o.textHeight);
            }
            this.element.val(this.options.text);
        },
        getValue: function () {
            return this.element.val();
        },
        setValue: function (value) {
            this.element.val(value);
        },
        getLastValidValue:function(){
            return this.valid_value;
        },
        validationChecker:function(){
            if( !this.options.allowBlank && BI.isEmpty( this.getValue() ) ){
                this.fireEvent("EVENT_ERROR");
            }else if( this.options.validationChecker.apply(this,arguments) ){
                this.valid_value = this.getValue();
                this.fireEvent("EVENT_VALID");
            }else{
                this.fireEvent("EVENT_ERROR");
            }
        },
        quitChecker:function(){
            if( !this.options.allowBlank && BI.isEmpty( this.getValue() ) ){
                return false;
            }
            return this.options.quitChecker.apply(this,arguments);
        }
    });
    BI.shortcut("swing.text_editor", Widget);

    var Text = Java.type("com.tptj.tool.hg.fineui.swing.element.TextElement");
    BI.config("bi.text_editor", function (config) {
        return BI.extend({}, config, {
            type: "swing.text_editor",
            swingElement: Text
        })
    });

})();